var _md5 = require('crypto').createHash('md5'),
	_fs = require('fs');

function md5(str) {
	return _md5.update(str).digest('hex');
}

function file_md5(filename, callback) {
	var fileStream = fs.createReadStream(filename);
	fileStream.on('error', function (err) {
		return callback(err, null)
	});
	fileStream.on('data', function (chunk) {
		try {
			_md5.update(chunk)
		} catch (ex) {
			return callback(ex, null)
		}
	});
	fileStream.on('end', function () {
		return callback(null, _md5.digest('hex'))
	});
}

function file_md5_sync(filename) {
	_md5.update(fs.readFileSync(filename));
	return _md5.digest('hex');
}


module.exports = md5;
module.exports.hex = md5;
module.exports.file = file_md5;
module.exports.fileSync = file_md5;